/* eucsbtype.c */
/* Ql: b}KW 1992/5
 *       libc (mbsbtype.c)
 */

static char rcsid[] = "$Id: eucsbtype.c,v 1.1 1994/07/30 05:49:23 JACK Exp $";

#include	"eucctype.h"
#include	"eucstring.h"


static int isfirst(const unsigned char *s, int n)
{
	int i;

	/* ȊO܂Ŗ߂ */
	for (i = n; i >= 0 && iseucfirst(s[i]); i--)
		;

	/* _̊1oCgڂ && {ɐR[hׂ */
	return ((n - i) & 1) && iseucfirst(s[n]);
}


int eucsbtype(const unsigned char *s, int n)
{
	/* 1oCgڂȁH */
	if (isfirst(s, n))
		return _EUC_FIRST;

	/* 2oCgڂȁH */
	if (n > 0 && isfirst(s, n-1))
		return _EUC_SECOND;

	/* R[hȁH */
	if (s[n] <= 0x1f || s[n] >= 0xfd)
		return _EUC_ILLEGAL;

	/* ȊOANK낤 */
	return _EUC_ANK;
}
