/* mdump.c */

static char rcsid[] = "$Id: mdump_bufput.c,v 1.1 1994/07/30 05:49:23 JACK Exp $";

#include	<stdlib.h>
#include	<mbctype.h>
#include	<mbstring.h>

#include	"mdump.h"
#include	"eucctype.h"
#include	"eucstring.h"


int hexput(char *p, register int value, short max)
{
	static char chr[] = "0123456789abcdef";

	p += max-1;
	while(max--) {
		*p-- = chr[value & 0xf];
		value >>= 4;
	}
	return 0;
}

/* QoCg̃T[`͈ */
#define	SEARCHSIZE	256

/* obt@SJISœWJ */
int mdump_line_sjisput(char *buf, struct fileinfo *finfo, int mode, int pos, char sepa)
{
	int offset, maxsize;
	int i;
	unsigned char *p;
	register unsigned char chr;

	char *pp;
	unsigned char *q;
	unsigned short c;

	offset = finfo->offset - OFFSET;
	offset += pos*16;
	maxsize = finfo->readsize - OFFSET;
	p = finfo->readbuf;
	p += offset;
	pp = buf;

	if (mode == 1) {
		q = (unsigned char*)buf+10+5*8+1;
	} else {
		q = (unsigned char*)buf+10+3*16+1;
	}

	hexput(pp, (offset+OFFSET), 8);
	pp += 8;
	*pp++ = sepa;
	*pp++ = ' ';
	for (i = 0; i < 16; i++) {
		if (offset+i < maxsize) {
			chr = *(p+i);
			hexput(pp, chr, 2);
			pp +=2;
			if (mode == 1) {
				if (i & 0x1) {
					/* Ȃ΋󔒑} */
					*pp++ = ' ';
				}
			} else {
				*pp++ = ' ';
			}
		} else {
			/* obt@TCY𒴂Ă */
			*pp++ = ' ';
			*pp++ = ' ';
			if (mode == 1) {
				if (i & 0x1) {
					/* Ȃ΋󔒑} */
					*pp++ = ' ';
				}
			} else {
				*pp++ = ' ';
			}
		}
	}
	*pp++ = ' ';

	i = 0;
	if (mbsbtype( max(finfo->readbuf,(p-SEARCHSIZE)),
				min((offset+0),SEARCHSIZE) ) == _MBC_TRAIL) {
		/* SJIS 񕶎 */
		/* 擪ʒuȂ󔒂\ */
		*q++ = ' ';
		i++;
	}

	/* ̕1oCgڂ */
	for ( ; i < 16; i++) {
		if (offset+i < maxsize) {
			chr = *(p+i);
			if (chr == 0x80 || (chr >= 0xf0 && chr <= 0xf3)) {
				/* 2oCgp */
				if (offset+i+1 < maxsize) {
					i++;
					if (ismbbtrail(*(p+i))) {
						*q++ = chr;
						*q++ = *(p+i);
						*q++ = ' ';
					} else {
						/* ُȂwx\ */
						*q++ = 0x81;
						*q++ = 0xA6;
					}
				} else {
					/* rŃobt@؂Ăꍇ */
					*q++ = 0x81;
					*q++ = 0xA6;
				}
			} else if (chr >= 0xf4) {
				if (offset+i+1 < maxsize) {
					i++;
					/* YȂ */
					*q++ = 0x81;
					*q++ = 0xA6;
				} else {
					/* rŃobt@؂Ăꍇ */
					*q++ = 0x81;
					*q++ = 0xA6;
				}
			} else {
				if (ismbblead(chr)) {
					/* SJIS ꕶ */
					if (offset+i+1 < maxsize) {
						/* ̕𓾂 */
						i++;
						c = (chr << 8) + *(p+i);
						if (ismbclegal(c & 0xffff)) {
							/* R[hΏo */
							*q++ = chr;
							*q++ = *(p+i);
						} else {
							/* ُȂwx\ */
							*q++ = 0x81;
							*q++ = 0xA6;
						}
					} else {
						/* rŃobt@؂Ăꍇ */
						*q++ = 0x81;
						*q++ = 0xA6;
					}
				} else {
					if (chr <= 0x1f || (chr >= 0x7f && chr <= 0x9f) || chr >= 0xe0) {
						/* \s\R[h '.' ɒu */
						*q++ = '.';
					} else {
						*q++ = chr;
					}
				}
			}
		} else {
			/* obt@TCY𒴂Ă */
			*q++ = ' ';
		}
	}
	*q++ = '\0';

	offset += 16;
	if (offset >= maxsize)	return 1;
	return 0;
}

/* obt@EUCœWJ */
int mdump_line_eucput(char *buf, struct fileinfo *finfo, int mode, int pos, char sepa)
{
	int offset, maxsize;
	int i;
	unsigned char *p;
	register unsigned char chr;

	char *pp;
	unsigned char *q;
	unsigned short c;

	offset = finfo->offset - OFFSET;
	offset += pos*16;
	maxsize = finfo->readsize - OFFSET;
	p = finfo->readbuf;
	p += offset;
	pp = buf;

	if (mode == 1) {
		q = (unsigned char*)buf+10+5*8+1;
	} else {
		q = (unsigned char*)buf+10+3*16+1;
	}

	hexput(pp, (offset+OFFSET), 8);
	pp += 8;
	*pp++ = sepa;
	*pp++ = ' ';
	for (i = 0; i < 16; i++) {
		if (offset+i < maxsize) {
			chr = *(p+i);
			hexput(pp, chr, 2);
			pp +=2;
			if (mode == 1) {
				if (i & 0x1) {
					/* Ȃ΋󔒑} */
					*pp++ = ' ';
				}
			} else {
				*pp++ = ' ';
			}
		} else {
			/* obt@TCY𒴂Ă */
			*pp++ = ' ';
			*pp++ = ' ';
			if (mode == 1) {
				if (i & 0x1) {
					/* Ȃ΋󔒑} */
					*pp++ = ' ';
				}
			} else {
				*pp++ = ' ';
			}
		}
	}
	*pp++ = ' ';

	i = 0;
	if (offset != 0 && *(p-2) == 0x8e) {
		/* pJiŏI */
		i = 0;
	} else if (offset != 0 && *(p-1) == 0x8e) {
		/* pJi̓񕶎ڂ */
		*q++ = ' ';
		i++;
	} else if (eucsbtype( max(finfo->readbuf,(p-SEARCHSIZE)),
				min((offset+0),SEARCHSIZE) ) == _EUC_SECOND) {
		/* EUC 񕶎 */
		/* 擪ʒuȂ󔒂\ */
		*q++ = ' ';
		i++;
	}

	/* ̕1oCgڂ */
	for ( ; i < 16; i++) {
		if (offset+i < maxsize) {
			chr = *(p+i);
			if (iseucfirst(chr)) {
				/* EUC ꕶ */
				if (offset+i+1 < maxsize) {
					/* ̕𓾂 */
					i++;
					c = (chr << 8) + *(p+i);
					if (iseuc(c & 0xffff)) {
						/* R[hΏo */
						c = eucsft(c & 0xffff);
						*q++ = (c >> 8) & 0xff;
						*q++ = c & 0xff;
					} else {
						/* ُȂwx\ */
						*q++ = 0x81;
						*q++ = 0xA6;
					}
				} else {
					/* rŃobt@؂Ăꍇ */
					*q++ = 0x81;
					*q++ = 0xA6;
				}
			} else {
				if (chr == 0x8e) {
					/* pJi */
					if (offset+i+1 < maxsize) {
						/* ̕𓾂 */
						i++;
						chr = *(p+i);
						if (chr >= 0xa1 && chr <= 0xdf) {
							*q++ = chr;
							*q++ = ' ';
						} else {
							/* ُȂwx\ */
							*q++ = 0x81;
							*q++ = 0xA6;
						}
					} else {
						/* rŃobt@؂Ăꍇ */
						*q++ = 0x81;
						*q++ = 0xA6;
					}
				} else if (chr <= 0x1f || (chr >= 0x7f && chr <= 0x9f) || chr >= 0xe0) {
					/* \s\R[h '.' ɒu */
					*q++ = '.';
				} else {
					*q++ = chr;
				}
			}
		} else {
			/* obt@TCY𒴂Ă */
			*q++ = ' ';
		}
	}
	*q++ = '\0';

	offset += 16;
	if (offset >= maxsize)	return 1;
	return 0;
}
