/* euctype.h */

/* $Id: eucctype.h,v 1.1 1994/07/30 05:49:23 JACK Exp $ */

#ifndef __eucctype_h__
#define __eucctype_h__

#ifndef __cdecl_h__
#include <cdecl.h>
#endif

#define	_EUCFIRST		0x10

#define	_EUCGETL(c)	((c) &  255)
#define	_EUCGETH(c)	(((c) >> 8) & 255)

extern const unsigned char *_eucctype;

extern int_ iseuc(int_);
extern int_ iseucfirst(int_);
extern int_ eucsbtype(const unsigned char *, int_);

#ifndef __NO_CTYPE_INLINE__

#define	iseuc(c)	(iseucfirst(_EUCGETL((unsigned char)(c)))	\
					&& iseucfirst(_EUCGETH((unsigned short)(c))))
#define	iseucfirst(c)	(_eucctype[(unsigned char)(c)] & _EUCFIRST)

#endif

#endif	/* __eucctype_h__ */
